<?php defined('SYSPATH') or die('No direct script access.');
  
class Model_Student extends Model
{
    private $id;

    public static function load($id) {
        $student = new self();
        $student->id = (int) $id;

        return $student;
    }


    /**
     * Send the student to an academic leave.
     */
    public function leave() {
        $sql = "CALL `ControlStudentGroup`(:id, -1, true');";

        DB::query(Database::SELECT, $sql)
            ->param(':id', $this->id)
            ->execute();
    }

    /**
     * @see students_groups.IsStudyLeave
     * @deprecated cause it's not implemented yet
     * @return true, if the student is on leave
     */
    public function hasLeft() {
        throw new BadMethodCallException("Method is not implemented yet!");
    }

    /**
     * Cancel the student's leave.
     * @param $group int  group id
     */
    public function attach($group) {
        $sql = "CALL `ControlStudentGroup`(:id, :group, false');";

        DB::query(Database::SELECT, $sql)
            ->param(':id', $this->id)
            ->param(':group', (int) $group)
            ->execute();
    }

    /*
     * TODO:
     *      a wrapper around `view_students` table
     *      see GetStudents, SearchStudents procedures.
     */
}
